#include <stdio.h>
#include <string.h>

#define LowercaseMask 0x20

/* conversion from Russkaja Latinica to DOS866 (alternative) */

unsigned char c0=EOF, c1=0, c2=0;	/* keep three consequtive characters */
unsigned char s1e []="wvabcdefghijklmnopqrstuxyz",
              s1r []="颠椥娩",
              s1rc[]="",

              s1me []="@'`~",	/* malleable */
              s1mr []="",
              s1mrc[]="",
              
              s2e1[]="sjjjjjjyyyzcse",	/* digraphs */
              s2e2[]="jeuao'`uaohhh'",
              s2r[] ="",
              s2rc[]="";
/*
   @    a    b    c    d    e    f    g    h    i    j */
/* unsigned char s1r[]=
{ 0355,0240,0241,0346,0244,0245,0344,0243,0345,0250,0251,
*/
/* k    l    m    n    o    p    q    r    s    t    u    v    w    x    y*/
/*
 0252,0253,0254,0255,0256,0257,0351,0340,0341,0342,0343,0242,0351,0345,0353,
*/
/* z    '    ~  */
/* 
 0247,0354,0352,0};
*/
/*
   @    a    b    c    d    e    f    g    h    i    j */
/*
unsigned char s1rc[]={
 0235,0200,0201,0226,0204,0205,0224,0203,0225,0210,0211,
*/
/* k    l    m    n    o    p    q    r    s    t    u    v    w    x    y*/
/*
 0212,0213,0214,0215,0216,0217,0231,0220,0221,0222,0223,0202,0231,0225,0233,
 0207,0234,0232,0};
unsigned char s2r []={0356,0357,0361,0347,0350,0246,0355,0};
unsigned char s2rc[]={0236,0237,0360,0227,0230,0206,0235,0};
*/

char Russian= 1;	/*  = 1 if translating Russian text, =0 if English */
unsigned char lowerc1;

void PutSingle(unsigned char c) {
	register unsigned i;
	unsigned char lowerc;
	lowerc=c | LowercaseMask;
	for (i=0; i<sizeof(s1e) && s1e[i]!=lowerc; i++);
	if (i<sizeof(s1e))
		putc( ( (c & LowercaseMask) ? s1r[i] : s1rc[i]),stdout);
	else putc(c,stdout);
}

unsigned int FindMalleable(unsigned char c) {
	register int i;
/* check for malleables */
	for (i=0; i<sizeof(s1me) && s1me[i]!=c;i++);
	return i;
}

unsigned IfMalleable (unsigned char c) {
	return (FindMalleable(c)<sizeof(s1me));	/*found a malleable?*/
}
#define UCMalleable(c) s1mrc[FindMalleable(c)]
#define LCMalleable(c) s1mr[FindMalleable(c)]

unsigned char MoldMalleable() {
	/* exceptions: at beginning of word */
	if (c1 == '`' && ! (c0 >= '@' && c0 <= 'z') ) return c1;
	if (c1 == '\'' && ! (c0 >= '@' && c0 <= 'z') ) return c1;
	/* general case: make it uppercase only if all neighbors are uppercase
	*/
	if (!(c0>='a' && c0<='z') && !(c2>='a' && c2<='z'))
		return UCMalleable(c1);
	else return LCMalleable(c1);
}
	
#define StringsMatch 0

int main(int argc, char **argv) {
	register int i;

/* get options */
	if (argc>1)
		for (i=1; i<argc; i++ ) {

			if (strcmp(argv[i],"w=v")==StringsMatch) {/* patch the tables */
				s1r[0]=s1r[1];	s1rc[0]=s1rc[1];
			}
			if (strcmp(argv[i],"nosj")==StringsMatch) {
				s2e1[0]=s2e1[1];	s2e2[0]=s2e2[1];
				s2r[0]=s2r[1];	s2rc[0]=s2rc[1];
			}
		}

	c1=getc(stdin); c2=getc(stdin);
	while (c1 != (unsigned char)EOF) {
		/* check our state */
		if (Russian==0) {
			if (c1 == '\\' && c2 == ' ') /* switch combination */ {
				Russian=1;	/* swallow it, don't output anything */
				c2=getc(stdin);
			} else /* output character without translation */
				putc(c1, stdout);
		} else /* Russian == 1 */
			/* check the backslash combinations */
			if (c1 == '\\') {
				switch(c2) {
				case ' ': /* switch combination */
					Russian=0;	/* swallow it, don't output anything */
					break;
				case '\\': /* escapes itself */
					putc (c1, stdout);
					break;
				default: /* either escapes the malleable symbol, or does nothing */
					/* check for malleables */
					if (IfMalleable(c2))
						putc(c2,stdout);
					else PutSingle(c2);
				}
				c2=getc(stdin);	/* because we had a 2-char combination */
			} else if (c1 == '^' || c1 == '_') { /* checking combinations with '^' and '_' */
				if (IfMalleable(c2)) {
					putc( (c1 == '^') ? UCMalleable(c2) : LCMalleable(c2), stdout);
				} else /* output the symbol itself */ putc(c1, stdout);
				c2=getc(stdin);	/* because we had a 2-char combination */
			} else {
		/* search first for doubles */
				lowerc1 = c1 | LowercaseMask;	/* bring c1 to lowercase */
				for (i=0;
	   				i<sizeof(s2e1) &&
	   				(s2e1[i]!=lowerc1 || s2e2[i]!= (c2 | LowercaseMask) );
	   		/* if the second character
	   		in the digraph is uppercase, the whole digraph becomes uppercase */
	   				i++);
				if (i<sizeof(s2e1))	/* found a double! */	{ 
			    	putc( ( ((c1 & LowercaseMask)&&(c2 & LowercaseMask)) ? s2r[i] : s2rc[i]),stdout);
			    	c2=getc(stdin);
				} else {	/* now search for malleables */
					if (IfMalleable(c1)) putc(MoldMalleable(), stdout);	
					else PutSingle(c1);
			    }
			}
		   	c0=c1; c1=c2; c2=getc(stdin);
			
    	}

	return 0;
}
